package tiw5.cineservice.model;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlID;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

@Entity
public class Salle {

    @Id
    @XmlID
    private String id;
    @XmlElement
    private int capacite = 0;
    @OneToMany(mappedBy = "salle", cascade = CascadeType.ALL)
    private Collection<Seance> seances = new ArrayList<Seance>();

    public Salle(String id, int capacite) {
        this.id = id;
        this.capacite = capacite;
    }

    protected Salle() {
    }

    public int getCapacite() {
        return capacite;
    }

    public Seance addSeance(Date date, Film film) {
        Seance seance = new Seance(film, this, date);
        seances.add(seance);
        return seance;
    }

    public void supprimeSeance(Seance se) {
        seances.remove(se);
        se.setSalle(null);
    }
}
