package tiw5.cineservice.model;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import javax.persistence.EntityManager;
import javax.persistence.Persistence;
import java.util.Collection;
import java.util.Date;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

/**
 * Created by Emmanuel Coquery on 17/09/14.
 */
public class JPATest {

    protected EntityManager em;

    @Before
    public void setupEm() {
        em = Persistence.createEntityManagerFactory("test").createEntityManager();
    }

    @After
    public void closeEm() {
        em.close();
    }

    @Test
    public void testMapping() {
    }

    @Test
    public void testReservation() {
        em.getTransaction().begin();
        Film f = new Film("film1", "Toto a l'ecole");
        f = em.merge(f);
        Salle s = new Salle("salle1", 3);
        s = em.merge(s);
        Seance se = s.addSeance(new Date(), f);
        em.persist(se);
        Collection<Reservation> reservations = se.reserver(10);
        assertEquals(0, reservations.size());
        reservations = se.reserver(2);
        assertEquals(2, se.getReservations().size());
        long seid = se.getId();
        em.getTransaction().commit();
        em.clear();
        em.getTransaction().begin();
        se = em.find(Seance.class, seid);
        assertNotNull("se non trouve: " + seid, se);
        se.supprimeReservations();
        em.getTransaction().commit();
        em.clear();
        em.getTransaction().begin();
        se = em.merge(se);
        assertNotNull(se);
        assertEquals(0, se.getReservations().size());
        s = em.merge(s);
        s.supprimeSeance(se);
        em.remove(se);
        em.getTransaction().commit();
        em.clear();
        em.getTransaction().begin();
        em.remove(em.merge(s));
        em.remove(em.merge(f));
        em.getTransaction().commit();
    }

}
