#!/bin/bash

if [ -z "$H2JAR" ]; then
    M2_REPOSITORY="$HOME/.m2/repository"
    sed=$(which gsed || which sed)
    groupId=com.h2database
    artifactId=h2
    version=1.4.181
    H2JAR="$M2_REPOSITORY/"$(echo "$groupId" | $sed 's/\./\//')"/$artifactId/$version/$artifactId-$version.jar"
    if [ ! -f $H2JAR ] ; then
        # download du jar via maven
        mvn "org.apache.maven.plugins:maven-dependency-plugin:2.1:get" "-Dartifact=$groupId:$artifactId:$version" "-DrepoUrl=http://repo1.maven.org/maven2"
    fi
fi
export H2JAR

