CREATE TABLE film(
	id VARCHAR(255) PRIMARY KEY,
	year INT,
	description CLOB,
	title VARCHAR(255),
	UNIQUE (title,year)
);

CREATE TABLE person(
	id VARCHAR(255) PRIMARY KEY,
	first_name VARCHAR(255),
	last_name VARCHAR(255)
);

CREATE TABLE direction(
	film VARCHAR(255) REFERENCES film(id),
	person VARCHAR(255) REFERENCES person(id),
	PRIMARY KEY (film,person)
);

CREATE TABLE genre(
	film VARCHAR(255) REFERENCES film(id),
	genre VARCHAR(255),
	PRIMARY KEY (film,genre)
);

CREATE TABLE performance(
	film VARCHAR(255) REFERENCES film(id),
	actor VARCHAR(255) REFERENCES person(id),
	film_character VARCHAR(255),
	PRIMARY KEY (film,film_character)
);

CREATE TABLE release(
	film VARCHAR(255) REFERENCES film(id),
	release_date DATE,
	medium VARCHAR(255),
	region VARCHAR(255),
	PRIMARY KEY (film,medium,region)
);

CREATE TABLE trailers(
	film VARCHAR(255) REFERENCES film(id),
	url VARCHAR(255),
	PRIMARY KEY (film,url)
);
